Skip to main content

A floating panel is a detachable window that floats above the main interface, typically used for displaying and editing properties. The panel can be dragged, resized, and positioned anywhere on the screen for optimal workflow.

Think of the panel that pops up in Figma when you click variables or try to set a color.

Loading...

Features

  • Allows interaction with the main content
  • Supports dragging and resizing
  • Supports minimizing and maximizing the panel
  • Controlled and uncontrolled size and position
  • Supports snapping to a grid
  • Supports locking the aspect ratio
  • Supports closing on escape key
  • Supports persisting size and position when closed

Installation

Install the floating panel package:

npm install @zag-js/floating-panel @zag-js/solid # or yarn add @zag-js/floating-panel @zag-js/solid

Anatomy

Check the floating panel anatomy and part names.

Each part includes a data-part attribute to help identify them in the DOM.

Usage

Import the floating panel package:

import * as floatingPanel from "@zag-js/floating-panel"

These are the key exports:

  • machine - State machine logic.
  • connect - Maps behavior to JSX props and event handlers.

Then use the framework integration helpers:

import * as floatingPanel from "@zag-js/floating-panel" import { useMachine, normalizeProps } from "@zag-js/solid" import { createMemo, createUniqueId } from "solid-js" import { ArrowDownLeft, Maximize2, Minus, XIcon } from "lucide-solid" function FloatingPanel() { const service = useMachine(floatingPanel.machine, { id: createUniqueId() }) const api = createMemo(() => floatingPanel.connect(service, normalizeProps)) return ( <> <button {...api().getTriggerProps()}>Toggle Panel</button> <div {...api().getPositionerProps()}> <div {...api().getContentProps()}> <div {...api().getDragTriggerProps()}> <div {...api().getHeaderProps()}> <p {...api().getTitleProps()}>Floating Panel</p> <div {...api().getControlProps()}> <button {...api().getStageTriggerProps({ stage: "minimized" })}> <Minus /> </button> <button {...api().getStageTriggerProps({ stage: "maximized" })}> <Maximize2 /> </button> <button {...api().getStageTriggerProps({ stage: "default" })}> <ArrowDownLeft /> </button> <button {...api().getCloseTriggerProps()}> <XIcon /> </button> </div> </div> </div> <div {...api().getBodyProps()}> <p>Some content</p> </div> <div {...api().getResizeTriggerProps({ axis: "n" })} /> <div {...api().getResizeTriggerProps({ axis: "e" })} /> <div {...api().getResizeTriggerProps({ axis: "w" })} /> <div {...api().getResizeTriggerProps({ axis: "s" })} /> <div {...api().getResizeTriggerProps({ axis: "ne" })} /> <div {...api().getResizeTriggerProps({ axis: "se" })} /> <div {...api().getResizeTriggerProps({ axis: "sw" })} /> <div {...api().getResizeTriggerProps({ axis: "nw" })} /> </div> </div> </> ) }

Resizing

Setting the initial size

To set the initial size of the floating panel, you can pass the defaultSize prop to the machine.

const service = useMachine(floatingPanel.machine, { defaultSize: { width: 300, height: 300 }, })

Controlling the size

Use size and onSizeChange to control size externally.

const service = useMachine(floatingPanel.machine, { size: { width: 300, height: 300 }, onSizeChange(details) { // details => { size: { width: number, height: number } } console.log("floating panel is:", details.size.width, details.size.height) }, })

Disable resizing

By default, the panel can be resized by dragging its edges (resize handles). To disable this behavior, set the resizable prop to false.

const service = useMachine(floatingPanel.machine, { resizable: false, })

Setting size constraints

You can also control the minimum allowed dimensions of the panel by using the minSize and maxSize props.

const service = useMachine(floatingPanel.machine, { minSize: { width: 100, height: 100 }, maxSize: { width: 500, height: 500 }, })

Aspect ratio

To lock the aspect ratio of the floating panel, set the lockAspectRatio prop. This will ensure the panel maintains a consistent aspect ratio while being resized.

const service = useMachine(floatingPanel.machine, { lockAspectRatio: true, })

Positioning

Setting the initial position

To specify the initial position of the floating panel, use the defaultPosition prop. If defaultPosition is not provided, the floating panel will be initially positioned at the center of the viewport.

const service = useMachine(floatingPanel.machine, { defaultPosition: { x: 500, y: 200 }, })

Anchor position

An alternative to setting the initial position is to provide a function that returns the anchor position. This function is called when the panel is opened and receives the triggerRect and boundaryRect.

const service = useMachine(floatingPanel.machine, { getAnchorPosition({ triggerRect, boundaryRect }) { return { x: boundaryRect.x + (boundaryRect.width - triggerRect.width) / 2, y: boundaryRect.y + (boundaryRect.height - triggerRect.height) / 2, } }, })

Controlling the position

To control the position of the floating panel programmatically, you can pass the position and onPositionChange prop to the machine.

const service = useMachine(floatingPanel.machine, { position: { x: 500, y: 200 }, onPositionChange(details) { // details => { position: { x: number, y: number } } console.log("floating panel is:", details.position.x, details.position.y) }, })

Disable dragging

The floating panel enables you to set its position and move it by dragging. To disable this behavior, set the draggable prop to false.

const service = useMachine(floatingPanel.machine, { draggable: false, })

Controlling positioning strategy

Use strategy to control positioning behavior (fixed or absolute).

const service = useMachine(floatingPanel.machine, { strategy: "absolute", })

Snapping to a grid

Use gridSize to snap drag and resize interactions to a grid.

const service = useMachine(floatingPanel.machine, { gridSize: 8, })

Allowing overflow outside boundaries

Set allowOverflow to true to let the panel move outside boundary limits.

const service = useMachine(floatingPanel.machine, { allowOverflow: true, })

Events

The floating panel generates a variety of events that you can handle.

Open State

When the floating panel is opened or closed, the onOpenChange callback is invoked.

const service = useMachine(floatingPanel.machine, { onOpenChange(details) { // details => { open: boolean } console.log("floating panel is:", details.open ? "opened" : "closed") }, })

Position Change

When the position of the floating panel changes, these callbacks are invoked:

  • onPositionChange — When the position of the floating panel changes.
  • onPositionChangeEnd — When the position of the floating panel changes ends.
const service = useMachine(floatingPanel.machine, { onPositionChange(details) { // details => { position: { x: number, y: number } } console.log("floating panel is:", details.position.x, details.position.y) }, onPositionChangeEnd(details) { // details => { position: { x: number, y: number } } console.log("floating panel is:", details.position.x, details.position.y) }, })

Resize

When the size of the floating panel changes, these callbacks are invoked:

  • onSizeChange — When the panel size changes.
  • onSizeChangeEnd — When panel resizing ends.
const service = useMachine(floatingPanel.machine, { onSizeChange(details) { // details => { size: { width: number, height: number } } console.log("floating panel is:", details.size.width, details.size.height) }, onSizeChangeEnd(details) { // details => { size: { width: number, height: number } } console.log("floating panel is:", details.size.width, details.size.height) }, })

Minimizing and Maximizing

The floating panel can be minimized, default, and maximized by clicking the respective buttons in the header. We refer to this as the panel's stage.

  • When the panel is minimized, the body is hidden and the panel is resized to a minimum size.

  • When the panel is maximized, the panel scales to the match the size of the defined boundary rect (via getBoundaryEl prop).

  • When the panel is restored, the panel is resized back to the previously known size.

When the stage changes, the onStageChange callback is invoked.

const service = useMachine(floatingPanel.machine, { onStageChange(details) { // details => { stage: "minimized" | "maximized" | "default" } console.log("floating panel is:", details.stage) }, })

Persisting size and position when closed

Set persistRect to true to preserve size and position across close and reopen.

const service = useMachine(floatingPanel.machine, { persistRect: true, })

Customizing accessibility labels

Use translations to customize stage control labels.

const service = useMachine(floatingPanel.machine, { translations: { minimize: "Minimize panel", maximize: "Maximize panel", restore: "Restore panel", }, })

Styling guide

The floating panel component uses data attributes to style its various parts. Each part has a data-scope="floating-panel" and data-part attribute that you can use to target specific elements.

[data-scope="floating-panel"][data-part="content"] { /* Add styles for the main panel container */ } [data-scope="floating-panel"][data-part="body"] { /* Add styles for the panel's content area */ } [data-scope="floating-panel"][data-part="header"] { /* Add styles for the panel's header */ } [data-scope="floating-panel"][data-part="stage-trigger"] { /* Add styles for state buttons in the header */ } [data-scope="floating-panel"][data-part="resize-trigger"] { /* Add styles for resize handles */ } /* North and south resize handles */ [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="n"], [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="s"] { /* Add styles for north and south resize handles */ } /* East and west resize handles */ [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="e"], [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="w"] { /* Add styles for east and west resize handles */ } /* Corner resize handles */ [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="ne"], [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="nw"], [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="se"], [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="sw"] { /* Add styles for corner resize handles */ }

Dragging

When dragging the panel, the [data-dragging] attribute is applied to the panel.

[data-scope="floating-panel"][data-part="content"][data-dragging] { /* Add styles for dragging state */ }

Stacking

The floating panel has several states that can be targeted using data attributes:

/* When the panel is the topmost element */ [data-scope="floating-panel"][data-part="content"][data-topmost] { /* Add styles for topmost state */ } /* When the panel is behind another panel */ [data-scope="floating-panel"][data-part="content"][data-behind] { /* Add styles for behind state */ }

Methods and Properties

Machine Context

The floating panel machine exposes the following context properties:

  • idsElementIds | undefinedThe ids of the elements in the floating panel. Useful for composition.
  • translationsIntlTranslations | undefinedThe translations for the floating panel.
  • strategy"absolute" | "fixed" | undefinedThe strategy to use for positioning
  • allowOverflowboolean | undefinedWhether the panel should be strictly contained within the boundary when dragging
  • openboolean | undefinedThe controlled open state of the panel
  • defaultOpenboolean | undefinedThe initial open state of the panel when rendered. Use when you don't need to control the open state of the panel.
  • draggableboolean | undefinedWhether the panel is draggable
  • resizableboolean | undefinedWhether the panel is resizable
  • sizeSize | undefinedThe size of the panel
  • defaultSizeSize | undefinedThe default size of the panel
  • minSizeSize | undefinedThe minimum size of the panel
  • maxSizeSize | undefinedThe maximum size of the panel
  • positionPoint | undefinedThe controlled position of the panel
  • defaultPositionPoint | undefinedThe initial position of the panel when rendered. Use when you don't need to control the position of the panel.
  • getAnchorPosition((details: AnchorPositionDetails) => Point) | undefinedFunction that returns the initial position of the panel when it is opened. If provided, will be used instead of the default position.
  • lockAspectRatioboolean | undefinedWhether the panel is locked to its aspect ratio
  • closeOnEscapeboolean | undefinedWhether the panel should close when the escape key is pressed
  • getBoundaryEl(() => HTMLElement | null) | undefinedThe boundary of the panel. Useful for recalculating the boundary rect when the it is resized.
  • initialFocusEl(() => HTMLElement | null) | undefinedElement to receive focus when the panel is opened. By default, the first focusable element in the content is focused.
  • finalFocusEl(() => HTMLElement | null) | undefinedElement to receive focus when the panel is closed. By default, the trigger element is focused.
  • restoreFocusboolean | undefinedWhether to restore focus to the trigger when the panel is closed.
  • disabledboolean | undefinedWhether the panel is disabled
  • onPositionChange((details: PositionChangeDetails) => void) | undefinedFunction called when the position of the panel changes via dragging
  • onPositionChangeEnd((details: PositionChangeDetails) => void) | undefinedFunction called when the position of the panel changes via dragging ends
  • onOpenChange((details: OpenChangeDetails) => void) | undefinedFunction called when the panel is opened or closed
  • onSizeChange((details: SizeChangeDetails) => void) | undefinedFunction called when the size of the panel changes via resizing
  • onSizeChangeEnd((details: SizeChangeDetails) => void) | undefinedFunction called when the size of the panel changes via resizing ends
  • persistRectboolean | undefinedWhether the panel size and position should be preserved when it is closed
  • gridSizenumber | undefinedThe snap grid for the panel
  • onStageChange((details: StageChangeDetails) => void) | undefinedFunction called when the stage of the panel changes
  • dir"ltr" | "rtl" | undefinedThe document's text/writing direction.
  • idstringThe unique identifier of the machine.
  • getRootNode(() => ShadowRoot | Document | Node) | undefinedA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.

Machine API

The floating panel api exposes the following methods:

  • openbooleanWhether the panel is open
  • setOpen(open: boolean) => voidFunction to open or close the panel
  • draggingbooleanWhether the panel is being dragged
  • resizingbooleanWhether the panel is being resized
  • positionPointThe position of the panel
  • setPosition(position: Point) => voidFunction to set the position of the panel
  • sizeSizeThe size of the panel
  • setSize(size: Size) => voidFunction to set the size of the panel
  • minimizeVoidFunctionFunction to minimize the panel
  • maximizeVoidFunctionFunction to maximize the panel
  • restoreVoidFunctionFunction to restore the panel before it was minimized or maximized
  • resizablebooleanWhether the panel is resizable
  • draggablebooleanWhether the panel is draggable

Data Attributes

Trigger
data-scope
floating-panel
data-part
trigger
data-state
"open" | "closed"
data-dragging
Present when in the dragging state
Content
data-scope
floating-panel
data-part
content
data-state
"open" | "closed"
data-dragging
Present when in the dragging state
data-topmost
Present when topmost
data-behind
Present when not topmost
data-minimized
Present when minimized
data-maximized
Present when maximized
data-staged
Present when not in default stage
StageTrigger
data-scope
floating-panel
data-part
stage-trigger
data-stage
The stage of the stagetrigger
ResizeTrigger
data-scope
floating-panel
data-part
resize-trigger
data-disabled
Present when disabled
data-axis
The axis to resize
DragTrigger
data-scope
floating-panel
data-part
drag-trigger
data-disabled
Present when disabled
Control
data-scope
floating-panel
data-part
control
data-disabled
Present when disabled
data-stage
The stage of the control
data-minimized
Present when minimized
data-maximized
Present when maximized
data-staged
Present when not in default stage
Header
data-scope
floating-panel
data-part
header
data-dragging
Present when in the dragging state
data-topmost
Present when topmost
data-behind
Present when not topmost
data-minimized
Present when minimized
data-maximized
Present when maximized
data-staged
Present when not in default stage
Body
data-scope
floating-panel
data-part
body
data-dragging
Present when in the dragging state
data-minimized
Present when minimized
data-maximized
Present when maximized
data-staged
Present when not in default stage

CSS Variables

Positioner
--width
The width of the element
--height
The height of the element
--x
The x position for transform
--y
The y position for transform
--reference-width
The width of the reference element
--reference-height
The height of the root
--available-width
The available width in viewport
--available-height
The available height in viewport
--z-index
The z-index value
--transform-origin
The transform origin for animations
Arrow
--arrow-size
The size of the arrow
--arrow-size-half
Half the size of the arrow
--arrow-background
Use this variable to style the arrow background
--arrow-offset
The offset position of the arrow
Edit this page on GitHub

Skip to main content

A floating panel is a detachable window that floats above the main interface, typically used for displaying and editing properties. The panel can be dragged, resized, and positioned anywhere on the screen for optimal workflow.

Think of the panel that pops up in Figma when you click variables or try to set a color.

Loading...

Features

  • Allows interaction with the main content
  • Supports dragging and resizing
  • Supports minimizing and maximizing the panel
  • Controlled and uncontrolled size and position
  • Supports snapping to a grid
  • Supports locking the aspect ratio
  • Supports closing on escape key
  • Supports persisting size and position when closed

Installation

Install the floating panel package:

npm install @zag-js/floating-panel @zag-js/vue # or yarn add @zag-js/floating-panel @zag-js/vue

Anatomy

Check the floating panel anatomy and part names.

Each part includes a data-part attribute to help identify them in the DOM.

Usage

Import the floating panel package:

import * as floatingPanel from "@zag-js/floating-panel"

These are the key exports:

  • machine - State machine logic.
  • connect - Maps behavior to JSX props and event handlers.

Then use the framework integration helpers:

<script setup> import * as floatingPanel from "@zag-js/floating-panel" import { normalizeProps, useMachine } from "@zag-js/vue" import { computed, useId } from "vue" import { Minus, Maximize2, ArrowDownLeft, XIcon } from "lucide-vue-next" const service = useMachine(floatingPanel.machine, { id: useId() }) const api = computed(() => floatingPanel.connect(service, normalizeProps)) </script> <template> <button v-bind="api.getTriggerProps()">Toggle Panel</button> <div v-bind="api.getPositionerProps()"> <div v-bind="api.getContentProps()"> <div v-bind="api.getDragTriggerProps()"> <div v-bind="api.getHeaderProps()"> <p v-bind="api.getTitleProps()">Floating Panel</p> <div v-bind="api.getControlProps()"> <button v-bind="api.getStageTriggerProps({ stage: 'minimized' })"> <Minus /> </button> <button v-bind="api.getStageTriggerProps({ stage: 'maximized' })"> <Maximize2 /> </button> <button v-bind="api.getStageTriggerProps({ stage: 'default' })"> <ArrowDownLeft /> </button> <button v-bind="api.getCloseTriggerProps()"> <XIcon /> </button> </div> </div> </div> <div v-bind="api.getBodyProps()"> <p>Some content</p> </div> <div v-bind="api.getResizeTriggerProps({ axis: 'n' })" /> <div v-bind="api.getResizeTriggerProps({ axis: 'e' })" /> <div v-bind="api.getResizeTriggerProps({ axis: 'w' })" /> <div v-bind="api.getResizeTriggerProps({ axis: 's' })" /> <div v-bind="api.getResizeTriggerProps({ axis: 'ne' })" /> <div v-bind="api.getResizeTriggerProps({ axis: 'se' })" /> <div v-bind="api.getResizeTriggerProps({ axis: 'sw' })" /> <div v-bind="api.getResizeTriggerProps({ axis: 'nw' })" /> </div> </div> </template>

Resizing

Setting the initial size

To set the initial size of the floating panel, you can pass the defaultSize prop to the machine.

const service = useMachine(floatingPanel.machine, { defaultSize: { width: 300, height: 300 }, })

Controlling the size

Use size and onSizeChange to control size externally.

const service = useMachine(floatingPanel.machine, { size: { width: 300, height: 300 }, onSizeChange(details) { // details => { size: { width: number, height: number } } console.log("floating panel is:", details.size.width, details.size.height) }, })

Disable resizing

By default, the panel can be resized by dragging its edges (resize handles). To disable this behavior, set the resizable prop to false.

const service = useMachine(floatingPanel.machine, { resizable: false, })

Setting size constraints

You can also control the minimum allowed dimensions of the panel by using the minSize and maxSize props.

const service = useMachine(floatingPanel.machine, { minSize: { width: 100, height: 100 }, maxSize: { width: 500, height: 500 }, })

Aspect ratio

To lock the aspect ratio of the floating panel, set the lockAspectRatio prop. This will ensure the panel maintains a consistent aspect ratio while being resized.

const service = useMachine(floatingPanel.machine, { lockAspectRatio: true, })

Positioning

Setting the initial position

To specify the initial position of the floating panel, use the defaultPosition prop. If defaultPosition is not provided, the floating panel will be initially positioned at the center of the viewport.

const service = useMachine(floatingPanel.machine, { defaultPosition: { x: 500, y: 200 }, })

Anchor position

An alternative to setting the initial position is to provide a function that returns the anchor position. This function is called when the panel is opened and receives the triggerRect and boundaryRect.

const service = useMachine(floatingPanel.machine, { getAnchorPosition({ triggerRect, boundaryRect }) { return { x: boundaryRect.x + (boundaryRect.width - triggerRect.width) / 2, y: boundaryRect.y + (boundaryRect.height - triggerRect.height) / 2, } }, })

Controlling the position

To control the position of the floating panel programmatically, you can pass the position and onPositionChange prop to the machine.

const service = useMachine(floatingPanel.machine, { position: { x: 500, y: 200 }, onPositionChange(details) { // details => { position: { x: number, y: number } } console.log("floating panel is:", details.position.x, details.position.y) }, })

Disable dragging

The floating panel enables you to set its position and move it by dragging. To disable this behavior, set the draggable prop to false.

const service = useMachine(floatingPanel.machine, { draggable: false, })

Controlling positioning strategy

Use strategy to control positioning behavior (fixed or absolute).

const service = useMachine(floatingPanel.machine, { strategy: "absolute", })

Snapping to a grid

Use gridSize to snap drag and resize interactions to a grid.

const service = useMachine(floatingPanel.machine, { gridSize: 8, })

Allowing overflow outside boundaries

Set allowOverflow to true to let the panel move outside boundary limits.

const service = useMachine(floatingPanel.machine, { allowOverflow: true, })

Events

The floating panel generates a variety of events that you can handle.

Open State

When the floating panel is opened or closed, the onOpenChange callback is invoked.

const service = useMachine(floatingPanel.machine, { onOpenChange(details) { // details => { open: boolean } console.log("floating panel is:", details.open ? "opened" : "closed") }, })

Position Change

When the position of the floating panel changes, these callbacks are invoked:

  • onPositionChange — When the position of the floating panel changes.
  • onPositionChangeEnd — When the position of the floating panel changes ends.
const service = useMachine(floatingPanel.machine, { onPositionChange(details) { // details => { position: { x: number, y: number } } console.log("floating panel is:", details.position.x, details.position.y) }, onPositionChangeEnd(details) { // details => { position: { x: number, y: number } } console.log("floating panel is:", details.position.x, details.position.y) }, })

Resize

When the size of the floating panel changes, these callbacks are invoked:

  • onSizeChange — When the panel size changes.
  • onSizeChangeEnd — When panel resizing ends.
const service = useMachine(floatingPanel.machine, { onSizeChange(details) { // details => { size: { width: number, height: number } } console.log("floating panel is:", details.size.width, details.size.height) }, onSizeChangeEnd(details) { // details => { size: { width: number, height: number } } console.log("floating panel is:", details.size.width, details.size.height) }, })

Minimizing and Maximizing

The floating panel can be minimized, default, and maximized by clicking the respective buttons in the header. We refer to this as the panel's stage.

  • When the panel is minimized, the body is hidden and the panel is resized to a minimum size.

  • When the panel is maximized, the panel scales to the match the size of the defined boundary rect (via getBoundaryEl prop).

  • When the panel is restored, the panel is resized back to the previously known size.

When the stage changes, the onStageChange callback is invoked.

const service = useMachine(floatingPanel.machine, { onStageChange(details) { // details => { stage: "minimized" | "maximized" | "default" } console.log("floating panel is:", details.stage) }, })

Persisting size and position when closed

Set persistRect to true to preserve size and position across close and reopen.

const service = useMachine(floatingPanel.machine, { persistRect: true, })

Customizing accessibility labels

Use translations to customize stage control labels.

const service = useMachine(floatingPanel.machine, { translations: { minimize: "Minimize panel", maximize: "Maximize panel", restore: "Restore panel", }, })

Styling guide

The floating panel component uses data attributes to style its various parts. Each part has a data-scope="floating-panel" and data-part attribute that you can use to target specific elements.

[data-scope="floating-panel"][data-part="content"] { /* Add styles for the main panel container */ } [data-scope="floating-panel"][data-part="body"] { /* Add styles for the panel's content area */ } [data-scope="floating-panel"][data-part="header"] { /* Add styles for the panel's header */ } [data-scope="floating-panel"][data-part="stage-trigger"] { /* Add styles for state buttons in the header */ } [data-scope="floating-panel"][data-part="resize-trigger"] { /* Add styles for resize handles */ } /* North and south resize handles */ [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="n"], [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="s"] { /* Add styles for north and south resize handles */ } /* East and west resize handles */ [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="e"], [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="w"] { /* Add styles for east and west resize handles */ } /* Corner resize handles */ [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="ne"], [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="nw"], [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="se"], [data-scope="floating-panel"][data-part="resize-trigger"][data-axis="sw"] { /* Add styles for corner resize handles */ }

Dragging

When dragging the panel, the [data-dragging] attribute is applied to the panel.

[data-scope="floating-panel"][data-part="content"][data-dragging] { /* Add styles for dragging state */ }

Stacking

The floating panel has several states that can be targeted using data attributes:

/* When the panel is the topmost element */ [data-scope="floating-panel"][data-part="content"][data-topmost] { /* Add styles for topmost state */ } /* When the panel is behind another panel */ [data-scope="floating-panel"][data-part="content"][data-behind] { /* Add styles for behind state */ }

Methods and Properties

Machine Context

The floating panel machine exposes the following context properties:

  • idsElementIds | undefinedThe ids of the elements in the floating panel. Useful for composition.
  • translationsIntlTranslations | undefinedThe translations for the floating panel.
  • strategy"absolute" | "fixed" | undefinedThe strategy to use for positioning
  • allowOverflowboolean | undefinedWhether the panel should be strictly contained within the boundary when dragging
  • openboolean | undefinedThe controlled open state of the panel
  • defaultOpenboolean | undefinedThe initial open state of the panel when rendered. Use when you don't need to control the open state of the panel.
  • draggableboolean | undefinedWhether the panel is draggable
  • resizableboolean | undefinedWhether the panel is resizable
  • sizeSize | undefinedThe size of the panel
  • defaultSizeSize | undefinedThe default size of the panel
  • minSizeSize | undefinedThe minimum size of the panel
  • maxSizeSize | undefinedThe maximum size of the panel
  • positionPoint | undefinedThe controlled position of the panel
  • defaultPositionPoint | undefinedThe initial position of the panel when rendered. Use when you don't need to control the position of the panel.
  • getAnchorPosition((details: AnchorPositionDetails) => Point) | undefinedFunction that returns the initial position of the panel when it is opened. If provided, will be used instead of the default position.
  • lockAspectRatioboolean | undefinedWhether the panel is locked to its aspect ratio
  • closeOnEscapeboolean | undefinedWhether the panel should close when the escape key is pressed
  • getBoundaryEl(() => HTMLElement | null) | undefinedThe boundary of the panel. Useful for recalculating the boundary rect when the it is resized.
  • initialFocusEl(() => HTMLElement | null) | undefinedElement to receive focus when the panel is opened. By default, the first focusable element in the content is focused.
  • finalFocusEl(() => HTMLElement | null) | undefinedElement to receive focus when the panel is closed. By default, the trigger element is focused.
  • restoreFocusboolean | undefinedWhether to restore focus to the trigger when the panel is closed.
  • disabledboolean | undefinedWhether the panel is disabled
  • onPositionChange((details: PositionChangeDetails) => void) | undefinedFunction called when the position of the panel changes via dragging
  • onPositionChangeEnd((details: PositionChangeDetails) => void) | undefinedFunction called when the position of the panel changes via dragging ends
  • onOpenChange((details: OpenChangeDetails) => void) | undefinedFunction called when the panel is opened or closed
  • onSizeChange((details: SizeChangeDetails) => void) | undefinedFunction called when the size of the panel changes via resizing
  • onSizeChangeEnd((details: SizeChangeDetails) => void) | undefinedFunction called when the size of the panel changes via resizing ends
  • persistRectboolean | undefinedWhether the panel size and position should be preserved when it is closed
  • gridSizenumber | undefinedThe snap grid for the panel
  • onStageChange((details: StageChangeDetails) => void) | undefinedFunction called when the stage of the panel changes
  • dir"ltr" | "rtl" | undefinedThe document's text/writing direction.
  • idstringThe unique identifier of the machine.
  • getRootNode(() => ShadowRoot | Document | Node) | undefinedA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.

Machine API

The floating panel api exposes the following methods:

  • openbooleanWhether the panel is open
  • setOpen(open: boolean) => voidFunction to open or close the panel
  • draggingbooleanWhether the panel is being dragged
  • resizingbooleanWhether the panel is being resized
  • positionPointThe position of the panel
  • setPosition(position: Point) => voidFunction to set the position of the panel
  • sizeSizeThe size of the panel
  • setSize(size: Size) => voidFunction to set the size of the panel
  • minimizeVoidFunctionFunction to minimize the panel
  • maximizeVoidFunctionFunction to maximize the panel
  • restoreVoidFunctionFunction to restore the panel before it was minimized or maximized
  • resizablebooleanWhether the panel is resizable
  • draggablebooleanWhether the panel is draggable

Data Attributes

Trigger
data-scope
floating-panel
data-part
trigger
data-state
"open" | "closed"
data-dragging
Present when in the dragging state
Content
data-scope
floating-panel
data-part
content
data-state
"open" | "closed"
data-dragging
Present when in the dragging state
data-topmost
Present when topmost
data-behind
Present when not topmost
data-minimized
Present when minimized
data-maximized
Present when maximized
data-staged
Present when not in default stage
StageTrigger
data-scope
floating-panel
data-part
stage-trigger
data-stage
The stage of the stagetrigger
ResizeTrigger
data-scope
floating-panel
data-part
resize-trigger
data-disabled
Present when disabled
data-axis
The axis to resize
DragTrigger
data-scope
floating-panel
data-part
drag-trigger
data-disabled
Present when disabled
Control
data-scope
floating-panel
data-part
control
data-disabled
Present when disabled
data-stage
The stage of the control
data-minimized
Present when minimized
data-maximized
Present when maximized
data-staged
Present when not in default stage
Header
data-scope
floating-panel
data-part
header
data-dragging
Present when in the dragging state
data-topmost
Present when topmost
data-behind
Present when not topmost
data-minimized
Present when minimized
data-maximized
Present when maximized
data-staged
Present when not in default stage
Body
data-scope
floating-panel
data-part
body
data-dragging
Present when in the dragging state
data-minimized
Present when minimized
data-maximized
Present when maximized
data-staged
Present when not in default stage

CSS Variables

Positioner
--width
The width of the element
--height
The height of the element
--x
The x position for transform
--y
The y position for transform
--reference-width
The width of the reference element
--reference-height
The height of the root
--available-width
The available width in viewport
--available-height
The available height in viewport
--z-index
The z-index value
--transform-origin
The transform origin for animations
Arrow
--arrow-size
The size of the arrow
--arrow-size-half
Half the size of the arrow
--arrow-background
Use this variable to style the arrow background
--arrow-offset
The offset position of the arrow
Edit this page on GitHub